$window = AddOnsGUI.getObject(0);
if(!isObject(AO_FavsHelper)) $window.add(new GuiSwatchCtrl(AO_FavsHelper) {
   profile = "BlockWindowProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "90 25";
   extent = "269 27";
   minExtent = "8 2";
   visible = "0";
   color = "78 83 235 240";

   new GuiTextCtrl() {
      profile = "BlockWindowProfile";
      horizSizing = "center";
      vertSizing = "bottom";
      position = "22 3";
      extent = "225 18";
      minExtent = "8 2";
      visible = "1";
      text = "^^^ Click a number to set favorites ^^^";
      maxLength = "255";
   };
});
if(!isObject(AO_SetFavs)) $window.add(new GuiBitmapButtonCtrl(AO_SetFavs) {
   profile = "BlockButtonProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "90 3";
   extent = "62 19";
   minExtent = "8 2";
   visible = "1";
   command = "if(AO_FavsHelper.isVisible()) { $AO_PickFav = false; AO_FavsHelper.setVisible(false); } else { $AO_PickFav = true; AO_FavsHelper.setVisible(true); }";
   text = "Set Favs ";
   groupNum = "-1";
   buttonType = "PushButton";
   bitmap = "base/client/ui/button1";
   lockAspectRatio = "0";
   alignLeft = "0";
   overflowImage = "0";
   mKeepCached = "0";
   mColor = "255 255 255 255";
});
for($i=0;$i<10;$i++) {
   switch ($i) {
      case 0: $p = 340;
      case 1: $p = 160;
      case 2: $p = 180;
      case 3: $p = 200;
      case 4: $p = 220;
      case 5: $p = 240;
      case 6: $p = 260;
      case 7: $p = 280;
      case 8: $p = 300;
      case 9: $p = 320;
   }
   if(!isObject(nameToID($n = "AO_FavButton" @ $i))) {
      $window.add($o = new GuiBitmapButtonCtrl() {
         profile = "BlockButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = $p SPC 3;
         extent = "19 19";
         minExtent = "8 2";
         visible = "1";
         command = "AO_clickFav($ThisControl, " @ $i @ ");";
         accelerator = "1";
         text = $i;
         groupNum = "-1";
         buttonType = "PushButton";
         bitmap = "base/client/ui/button2";
         lockAspectRatio = "0";
         alignLeft = "0";
         overflowImage = "0";
         mKeepCached = "0";
         mColor = "255 255 255 128";
      });
      $o.setName($n);
   }
}
function AOFavRefresh() {
   for(%i=0;%i<10;%i++) {
      if(isFile("config/client/AddOnFavorites/" @ %i @ ".cs"))
         nameToID("AO_FavButton" @ %i).mColor = "255 255 255 255";
      else
         nameToID("AO_FavButton" @ %i).mColor = "255 255 255 128";
   }
}
function AO_clickFav(%obj, %i) {
   if($AO_PickFav) {
      saveAddOnFavorite(%i);
      AOFavRefresh();
      eval(AO_SetFavs.command);
   }
   else if(%obj.mColor $= "255 255 255 255")
      loadAddOnFavorite(%i);
}
function saveAddOnFavorite(%i) {
   addOnsGUI.onSleep();
   export("$AddOn__*", "config/client/AddOnFavorites/" @ %i @ ".cs");
}
function loadAddOnFavorite(%i) {
   if(!isFile(%f = "config/client/AddOnFavorites/" @ %i @ ".cs"))
      return;
   exec(%f);
   addOnsGUI.onWake();
}
package addOnFavs {
   function addOnsGUI::onWake(%this) {
      AOFavRefresh();
      Parent::onWake(%this);
   }
};
activatePackage(addOnFavs);